guru/guru3/urls.py
from django.conf import settings
from django.contrib.auth import views as auth_views
from django.contrib.auth.decorators import login_required
from django.urls import path, re_path, include, reverse_lazy, register_converter
from django.views.generic import RedirectView
from django.views.static import serve
from django_registration.backends.activation.views import RegistrationView
from core.forms.auth import RegistrationFormUniqueEmailWithProfile, GuruAuthenticationForm
from core.converters import LegacyHostingConverter, legacyPath
from core.views.common import SupportView

register_converter(LegacyHostingConverter, 'ext')

@login_required
def protected_serve(request, path, document_root=None, show_indexes=False):
    return serve(request, path, document_root, show_indexes)

urlpatterns = [
     path('', RedirectView.as_view(
        url = reverse_lazy("event.phonebook", kwargs={'ext':'php'}),
     )),
     path('api/', include('core.urls.api')),
     path('admin/', include('core.urls.admin')),
     legacyPath('event.<ext:ext>/', include('core.urls.events')),
     path('event/', include('core.urls.events')),
     legacyPath('extension.<ext:ext>/', include('core.urls.extension')),
     path('extension/', include('core.urls.extension')),
     legacyPath('handset.<ext:ext>/', include('core.urls.handset')),
     path('handset/', include('core.urls.handset')),
     path('callgroup/', include('core.urls.callgroup')),
     legacyPath('callgroup.<ext:ext>/', include('core.urls.callgroup')),
     path('grandstream/', include('grandstream.urls')),
     path('snom/', include('snom.urls')),
     path('epddi/', include('epddi.urls')),
     path('inventory/', include('core.urls.inventory')),
     legacyPath('register.<ext:ext>', RegistrationView.as_view(
        form_class = RegistrationFormUniqueEmailWithProfile,
    ),
         name = "user.register"),
     path('register', RegistrationView.as_view(
        form_class = RegistrationFormUniqueEmailWithProfile,
    ),
         name = "user.register"),
    legacyPath('accounts.<ext:ext>/', include('django.contrib.auth.urls')),
    path('accounts/', include('django.contrib.auth.urls')),
    legacyPath('accounts.<ext:ext>/', include('django_registration.backends.activation.urls')),
    path('accounts/', include('django_registration.backends.activation.urls')),
    legacyPath('accounts/login.<ext:ext>', auth_views.LoginView.as_view(),
          {'template_name': 'registration/login.html',
           'authentication_form': GuruAuthenticationForm},
          name = 'login'),
    path('accounts/login', auth_views.LoginView.as_view(),
          {'template_name': 'registration/login.html',
           'authentication_form': GuruAuthenticationForm},
          name = 'login'),
    legacyPath('user.<ext:ext>/', include('core.urls.user')),
    path('user/', include('core.urls.user')),
    path('captcha/', include('captcha.urls')),
    path("support/",
         SupportView.as_view(
             template_name="support.html",
         ),
         name="support"),
    legacyPath('audio.<ext:ext>/', include('core.urls.audio')),
    path('audio/', include('core.urls.audio')),
    re_path(r'^%s(?P<path>.*)$' % settings.MEDIA_URL[1:], protected_serve, {'document_root': settings.MEDIA_ROOT}),
]

if not settings.DEBUG:
    from django.conf.urls import handler404
    from django.shortcuts import render
    handler404 = lambda req, exception: render(req, "404.html", {}, status=404)

guru/snom/urls.py
from django.urls import re_path

from gcontrib.decorators import user_is_staff
from snom.views import provisioning

urlpatterns = [
    re_path(r"^prov/(?P<mac>[a-fA-Z0-9]{12})",
            provisioning,
            name="snom.provisioning"),
    re_path(r"^provdebug/(?P<mac>[a-fA-Z0-9]{12})",
            user_is_staff(provisioning),
            kwargs={"admin": True},
            name="snom.provisioning.debug"),
]

guru/core/forms/audio.py
import hashlib

import magic
from crispy_forms.helper import FormHelper
from crispy_forms.layout import Submit
from dal import autocomplete
from django.core.exceptions import ValidationError
from django.forms import ModelForm
from django.utils.translation import gettext_lazy as _

from core.models import AudioFile


class AudioFileForm(ModelForm):
    class Meta:
        model = AudioFile
        fields = [
            "name",
            "file",
        ]
        widgets = {
            "owner": autocomplete.ModelSelect2(url="user.autocomplete"),
        }

    def __init__(self, *args, **kwargs):
        self.user = kwargs.pop("user")
        super(AudioFileForm, self).__init__(*args, **kwargs)

    def get_form_helper(self):
        helper = FormHelper()
        helper.add_input(Submit("save", _("Add Audio File")))
        return helper

    def clean_file(self):
        file_count = AudioFile.objects.filter(owner=self.user).count()
        if file_count > 5 and not self.user.is_staff:
            raise ValidationError(_('User quota exceeded. Delete files first. 5 files maximum.'), code='maxfiles')
        file = self.cleaned_data.get('file', False)
        if file.size > (5*1024*1024):
            raise ValidationError(_('Audio File is to large (>5MB)'), code='toolarge')
        buf = file.read()
        mime = magic.from_buffer(buf, mime=True)
        if mime not in ['audio/mpeg', 'audio/x-wav']:
            raise ValidationError(_('File format [%s] is wrong. Only MP3 and WAV is supported.' % mime),
                                  code='wrongformat')
        hash_object = hashlib.sha512(buf)
        self.instance.sha512 = hash_object.hexdigest()
        return file

guru/core/forms/callgroup.py
from collections import OrderedDict

from django import forms
from django.core.exceptions import ValidationError
from django.contrib.auth.models import User
from django.utils.translation import gettext_lazy as _

from core.models import Extension, RecursiveSearchDepthLimitExceededException

from gcontrib.forms.factory import form_factory


class UsernameInput(forms.TextInput):
    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self._cached_results = {}

    def format_value(self, value):
        if value is None or value == '':
            return None
        if isinstance(value, str):
            return value
        if isinstance(value, User):
            return value.username

    def value_from_datadict(self, data, files, name):
        if name not in self._cached_results:
            try:
                user = User.objects.get(username=data.get(name, ""))
                self._cached_results[name] = user.pk
                return user.pk
            except User.DoesNotExist:
                input_data = data.get(name, "")
                # filter out pure numbers to prevent the underlying ModelChoice from interpreting it as valid pk
                if input_data.isnumeric():
                    return ""
                else:
                    return input_data
        else:
            return self._cached_results[name]


class InviteFormMixin:
    def __init__(self, *args, **kwargs):
        self.event = kwargs.pop("event")
        self.group = kwargs.pop("group")
        self.requester = kwargs.pop("requester")
        super().__init__(*args, **kwargs)

    @staticmethod
    def path_format(path):
        return " -> ".join(path)

    def clean_extension(self):
        extension = self.cleaned_data.get("extension")
        if extension is None:
            self.add_error("extension", ValidationError(_("No extension given"), code="extension-invalid"))

        try:
            ext = Extension.objects.get(event=self.event, extension=extension)
            if ext in self.group.group_members.all():
                self.add_error("extension", ValidationError(_("This extension is already part of the group."),
                                                            code="extension-already-present"))

            # check if it is recursively reachable
            try:
                result = ext.recursive_member_search(self.group.extension, [],
                                                     Extension.ALLOWED_GROUP_RECURSION_DEPTH)
                if result is not None:
                    self.add_error("extension", ValidationError(_("Adding this extension creates a loop: ")
                                                                + self.path_format(result),
                                                                code="extension-creates-loop"))
            except RecursiveSearchDepthLimitExceededException as e:
                self.add_error("extension",
                               ValidationError(_("The following path exceeds the current recursion limit: ") +
                                               self.path_format(e.path), code="extension-recursion-limit"))

            if ext.sip_trunk:
                self.add_error("extension", ValidationError(_("Trunk extensions cannot be part of groups / multiring"),
                                                            code="extension-is-trunk"))

            return ext
        except Extension.DoesNotExist:
            self.add_error("extension", ValidationError(_("This extension does not exist."),
                                                        code="extension-doesnt-exist"))

    def clean(self):
        if self.group.sip_trunk:
            raise ValidationError(_("Misconfiguration: You cannot add members to trunks"))
        return super().clean()


class InviteForm(InviteFormMixin, forms.Form):
    extension = forms.CharField(max_length=32, label=_("Extension"))
    invite_reason = forms.CharField(max_length=64, required=False, label=_("Invitation text"))


class MultiringInviteForm(InviteFormMixin, forms.Form):
    extension = forms.CharField(max_length=32, label=_("Extension"))

    def clean_extension(self):
        ext = super().clean_extension()
        if not isinstance(ext, Extension):
            return ext

        # additional permission check if multiring is allowed, we require that the user has
        # write permission to the target extension (e.i., owner, admin, group admin)
        if not ext.has_write_permission(self.requester):
            self.add_error("extension", ValidationError(_("You must own the extension that you want to add "
                                                          "for multiring"), code="extension-not-allowed"))
        return ext


CALLGROUP_MAX_MEMBER_DELAY = 600


def generate_delay_form(invites):
    fields = [
        ("delay_" + str(invite.pk), forms.IntegerField(min_value=0, max_value=CALLGROUP_MAX_MEMBER_DELAY))
        for invite in invites
    ]
    return form_factory("DelaysForm", OrderedDict(fields))

guru/core/forms/handset.py
from django.forms import ModelForm

from core.models import DECTHandset


class HandsetEditForm(ModelForm):
    class Meta:
        model = DECTHandset
        fields = [
            "description",
            "vendor",
            "model_designation",
            "ipei",
        ]

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.fields["ipei"].disabled = True

guru/core/views/audio.py
import os

from django.conf import settings
from django.http import FileResponse, HttpResponse, Http404

from core.models import AudioFile
from core.tasks import process_ringback_file

from gcontrib.views.edit import OwnerSettingCrispyCreateView


class CreateRingbackView(OwnerSettingCrispyCreateView):
    def form_valid(self, form):
        result = super().form_valid(form)
        process_ringback_file.delay(form.instance.pk)
        return result


def download_audio(source_dir, request, hash):
    # Just check if this exists in principle
    if not AudioFile.objects.filter(sha512=hash).exists():
        raise Http404()

    outfile = os.path.join(source_dir, hash) + ".slin"
    # check if conversion ready
    if not os.path.isfile(outfile):
        return HttpResponse(b"Converted audio not available yet.", status=425)

    return FileResponse(open(outfile, "rb"))

guru/core/views/common.py
import json

import celery.exceptions
from celery.result import AsyncResult
from django.core.exceptions import PermissionDenied
from django.db import transaction
from django.db.models import Prefetch
from django.http import Http404, JsonResponse, HttpResponseBadRequest, HttpResponse
from django.template.response import TemplateResponse
from django.views.decorators.csrf import csrf_exempt
from django.views.decorators.http import require_http_methods
from django.views.generic import TemplateView

from core import messaging
from core.models import PERM_ORGA, Event, Extension, WireMessage, IncomingWireMessage, InventoryLend
from core.session import getCurrentEvent
from guru3.consumers import notify_clients


def phonebookSearch(query, request):
    event = getCurrentEvent(request)
    if event is None:
        raise Http404
    if not event.isPhonebookPublic() and not request.user.is_authenticated:
        raise PermissionDenied

    results = event.searchExtensions(query)
    return results.filter(inPhonebook=True)

def gelbeseitenSearch(query, request):
    results = phonebookSearch(query, request)
    return results.exclude(name__isnull=True).exclude(name__exact='')

def orga_phonebook_search(query, request):
    event = getCurrentEvent(request)
    if event is None:
        raise Http404

    extensionResults = event.searchExtensions(query)    
    ownerResults = Extension.objects.filter(event=event, owner__username__icontains=query)
    return (extensionResults | ownerResults)\
        .distinct()\
        .filter(owner__organizedEvents=event).prefetch_related(
        Prefetch("inventorylend_set", queryset=InventoryLend.objects.filter(backDate__isnull=True)
                                                                    .select_related("item", "item__itemType"),
                 to_attr="active_lendings")
    )


def celery_task_status_view(request, taskid):
    result = AsyncResult(taskid)
    if not result.ready():
        try:
            result.get(timeout=0.5, propagate=False)
        except celery.exceptions.TimeoutError:
            pass
    response_data = {
        "status": result.status,
    }
    if result.info is not None:
        if isinstance(result.info, Exception):
            response_data["info"] = f"{result.info.__class__.__name__}: {str(result.info)}"
        else:
            response_data["info"] = result.info if isinstance(result.info, dict) or isinstance(result.info, list) \
                else str(result.info)

    return JsonResponse(response_data)


def vacationView(request):
    vr = TemplateResponse(request, "vacation.html", {})
    return vr


@csrf_exempt
@require_http_methods(["GET", "POST"])
def wireMessageView(request, pk, event=None):
    mgr_key_event = event
    try:
        event = Event.objects.get(pk=pk)
    except Event.DoesNotExist:
        raise Http404
    if mgr_key_event is not None and mgr_key_event != event:
        raise PermissionDenied

    if request.method == "GET":
        max_messages = request.GET.get("max_messages", "10")
        if not max_messages.isnumeric():
            return HttpResponseBadRequest()
        max_messages = int(max_messages)
        msgs = WireMessage.objects.filter(event=event, delivered=False).order_by("timestamp", "pk")[:max_messages]
        data = [msg.getWireData() for msg in msgs]
        return JsonResponse(data, safe=False)
    elif request.method == "POST":
        acklistStr = request.POST.get("acklist", "")
        messagesStr = request.POST.get("messages")
        try:
            acklist = json.loads(acklistStr)
            if messagesStr is not None:
                messages = json.loads(messagesStr)
            else:
                messages = []
        except json.decoder.JSONDecodeError as e:
            print(str(e))
            return HttpResponseBadRequest()
        if type(acklist) != list:
            return HttpResponseBadRequest()
        if type(messages) != list:
            return HttpResponseBadRequest()
        if any([type(e) != int for e in acklist]):
            return HttpResponseBadRequest()

        WireMessage.objects.filter(pk__in=acklist).update(delivered=True)
        notify_clients(pk,{"action": "messagecount",
                           "queuelength": WireMessage.objects.filter(event=pk, delivered=False).count()})

        message_results = []
        for message in messages:
            remote_id, status, msg = process_incoming_message(message, event)
            message_results.append({
                "id": remote_id,
                "status": status,
                "text": msg,
            })

        result = {
            "messages": message_results,
        }

        return JsonResponse(result)


def process_incoming_message(message_data, event):
    remote_id = message_data.get("id")
    try:
        with transaction.atomic():
            wm = IncomingWireMessage.parse_from(message_data)
            wm.event = event
            wm.save()

            msg = messaging.parse_incoming_wiremessage(wm)
            msg.process()
            wm.processed = True
            wm.save()
    except messaging.MessageParsingError as e:
        return remote_id, "NAK", "Parsing error: " + str(e)
    except messaging.MessageProcessingError as e:
        return remote_id, "NAK", "Processing error: " + str(e)

    return remote_id, "OK", ""


class SupportView(TemplateView):
    pass

guru/core/templates/extension/add_rental.html
{% extends "master.html" %}
{% load crispy_forms_tags %}

{% block current_event %}
{{form.event.name}}
{% endblock %}

{% block content %}
<h2>Apply for rental device</h2>

{% crispy form form_helper %}


{% endblock %}

guru/core/templates/extension/delete.html
{% extends "master.html" %}
{% load crispy_forms_tags %}

{% block content %}
<div class="row">
<div class="col-md-6" style="margin: 0 auto;">
        <h2>Delete Extension</h2>
        <form method="POST">
            {% csrf_token %}
            Do you really want to remove the {% if object.type == "GROUP" %}callgroup{% else %}extension{% endif %} {{object.extension}} ({{object.name}})?
            <p class="text-danger">
            <strong>WARNING:</strong>
            {% if object.type == "GROUP" %}
                Deleting the group will permanently remove the member and admin list.
            {% else %}
                Deleting the extension will disable the connected phone and remove it from all call groups.
            {% endif %}
            </p>
            {% if object.is_forward_target %}
            <div class="alert alert-warning">
                This extension is the target of an active call forwarding. This forward will be deactivated when you
                delete the extension.
            </div>
            {% endif %}
            {{form.as_p}}
            <div class="form-actions">
                <button type="Submit" class="btn btn-danger">Delete</button>
                <a href="{{next_view_path}}" class="btn">Cancel</a>
            </div>
        </form>
    </div>
</div>
{% endblock %}

guru/core/templates/extension/keyentry.html
{% load guru3 %}
                {% if ext.type == "DECT" %}
                <span class="oi oi-key" data-toggle="popover" title="Token: 9955-{{ext.registerToken|tokenformat}}" data-content="Your DECT number claim token is 9955-{{ext.registerToken|tokenformat}}. Call this number on your DECT!"></span>
                {% elif ext.type == "GSM" %}
                <span class="oi oi-key" data-toggle="popover" title="Token: 9955-{{ext.registerToken|tokenformat}}" data-html="true" data-content='Your GSM number claim token is <a href="tel:9955{{ext.registerToken}}">9955-{{ext.registerToken|tokenformat}}</a>. Call this number on your GSM phone!'></span>
                {% elif ext.type == "SIP" %}
                <span class="oi oi-key" data-toggle="popover" title="Your SIP account details" data-html="true" data-content='Server/Registrar: {{ext.sip_server}}<br />AuthUser: {{ext.extension}}<br />Password: <span style="font-family:monospace,monospace;">{{ext.sipPassword}}</span><br><form method="POST" action="{% url "extension.regeneratesippassword" pk=ext.pk %}">{% csrf_token %}<button title="Regenerate Password" type="Submit" class="btn btn-danger mt-2">Regenerate Password</button></form>'></span>
                {% endif %}

guru/core/templates/extension/multiring_editor.html
{% extends "master.html" %}
{% load legacy_url %}
{% load crispy_forms_tags %}

{% block content %}
<h1>Extension {{object.extension}} ({{object.name}})</h1>
<ul class="nav nav-pills mb-3">
    <li class="nav-item">
        <a class="nav-link" href="{% url "extension.edit" pk=object.pk %}{% if request.GET.next_url %}?next_url={{request.GET.next_url}}{% endif %}">Config</a>
    </li>
    <li class="nav-item">
        <a class="nav-link active" href="#">Multiring</a>
    </li>
    <li class="nav-item mr-3">
        <a class="nav-link" href="{% url "extension.references" pk=object.pk %}{% if request.GET.next_url %}?next_url={{request.GET.next_url}}{% endif %}">References</a>
    </li>
    {% if object.type == "DECT" %}
    <li class="nav-item">
        <div class="form-actions">
            <form method="POST" action="{% url "extension.unsubscribe" pk=object.pk %}">
            {% csrf_token %}
            <button title="Unsubscribe's your current DECT phone, which renders your extensions available again." type="Submit" class="btn btn-danger">
                Unsubscribe DECT
            </button>
            </form>
        </div>
    </li>
    {% endif %}
</ul>

<p>Multiring allows you to configure additional extensions from yours that should
ring additionally when this extension here is called. This way you can, for example,
configure a desktop SIP phone to also ring when your DECT is called.</p>
<p>Please note that you can only add your own extensions as multiring extensions
here. If you need a complexer group ring setup, please create a callgroup.</p>

<h2>Current multiring extensions</h2>
{% include "membership_table.html" with group=False %}

<h2>Add multiring extensions</h2>
{% crispy form_invite_member invite_member_helper %}

<script>
$(function () {
  $('[data-toggle="popover"]').popover()
})
</script>
{% endblock %}

guru/core/templates/extension/unused.html
{% extends "master.html" %}

{% block content %}

<h1>Unused {{ event.name }} Extensions ({{ event.unusedExtensionQuery|length }})</h1>
<input type="text" placeholder="Search" id="search" class="form-control">
<style>
#extensions [data-search]{ display:none;}
</style>
<style id="searchstyle">
    #extensions [data-search] {display:inline;}
</style>
<p id="extensions">
    {% for extension in event.getAllFreeExtensions %}
    <span data-search="{{extension}}">{{extension}}</span>
    {% endfor %}
</p>

<script type="text/javascript">
document.getElementById('search').addEventListener('input', function(){
    var style = document.getElementById('searchstyle');
    var css = '#extensions [data-search]';
    var value = document.getElementById('search').value;
    var parts = value.split(' ');
    for (var i = 0; i < parts.length; i++){
        if (parts[i].length === 0) continue;
        css += `[data-search*="${parts[i]}"]`;
    }
    css+='{display:inline;}';
    style.innerText = css;
});
</script>

{% endblock %}

guru/core/templates/extension/update.html
{% extends "master.html" %}
{% load crispy_forms_tags %}
{% load legacy_url %}
{% block current_event %}
{{form.event.name}}
{% endblock %}

{% block content %}
{% if object %}
<h1>Extension {{object.extension}} ({{object.name}})</h1>
{% else %}
<h1>Create new {% if form.fields.type.initial == "GROUP" %}callgroup{% else %}extension{% endif %}</h1>
{% endif %}

{% if object and object.type != "GROUP" %}
<ul class="nav nav-pills mb-3">
    <li class="nav-item">
        <a class="nav-link active" href="#">Config</a>
    </li>
    {% if not object.sip_trunk %}
    {% if not object.type == "ANNOUNCEMENT" and not object.type == "SPECIAL" and not object.type == "APP" %}
    <li class="nav-item">
        <a class="nav-link" href="{% url "extension.multiring" pk=object.pk %}{% if request.GET.next_url %}?next_url={{request.GET.next_url}}{% endif %}">Multiring</a>
    </li>
    {% endif %}
    <li class="nav-item mr-3">
        <a class="nav-link" href="{% url "extension.references" pk=object.pk %}{% if request.GET.next_url %}?next_url={{request.GET.next_url}}{% endif %}">References</a>
    </li>
    {% if object.type == "DECT" %}
    <li class="nav-item">
        <div class="form-actions">
            <form method="POST" action="{% url "extension.unsubscribe" pk=object.pk %}">
                {% csrf_token %}
                <button title="Unsubscribe's your current DECT phone, which renders your extensions available again." type="Submit" class="btn btn-danger">
                    Unsubscribe DECT
                </button>
            </form>
        </div>
    </li>
    {% endif %}
    {% else %}
    <li class="nav-item">
        <a class="nav-link disabled" href="#">Multiring</a>
    </li>
    <li class="nav-item disabled mr-3">
        <a class="nav-link disabled" href="#">References</a>
    </li>
    {% endif %}
</ul>
{% endif %}

{% if object and object.currentLending %}
{{object.currentLending.hook_display_extension}}
{% endif %}

{% if form.errors %}
<div class="alert alert-danger" role="alert">
    Please correct your inputs!
</div>
{% endif %}

{% crispy form form.get_form_helper %}

<script>
    function updateExtraBox(newType) {
        $(".form-ext-specific").hide();
        $(".form-ext-specific[data-extension-type=\""+ newType + "\"]").show();
    }

    function updateForwardDisplay(currentType) {
            if (currentType != "ENABLED") {
                $("#div_id_forward_delay").hide();
            } else {
                $("#div_id_forward_delay").show();
            }
    }

    $(document).ready(function () {
        var currType = $("#id_type").val();
        updateExtraBox(currType);
        updateForwardDisplay($("#id_forward_mode").val());

        $("#id_forward_mode").change(function () {
            updateForwardDisplay($(this).val());
        });

        $("#id_type").change(function () {
            var newType = $(this).val();
            updateExtraBox(newType);
        });
        var $extension = $('#id_extension');
        var hint_id_extension = $('#hint_id_extension').detach();
        hint_id_extension.insertAfter($extension.parent());
        $extension.parent().addClass("input-group");
        $extension.after('<div class="input-group-append">' +
            '<button class="btn btn-outline-secondary" type="button" id="random_extension" title="I\'m too lazy: generate one for me"><span class="oi oi-random"></span></button>' +
            '<a class="btn btn-outline-secondary" role="button" title="I want to see all available extensions" href="{% legacy_url "extension.unused" event=form.event.pk %}" target="_blank"><span class="oi oi-list"></span></a>' +
            '</div>');
        $('#random_extension').click(function() {
            $.get("{% url "event.random" pk=form.event.pk %}", function(data) {
                $("#id_extension").val(data);
            });
        });
        {% if object.sip_trunk %}
        $("#forward_grouper").hide();
        {% endif %}
    });
</script>
<style>
#div_id_twoGOptIn label:after,
#div_id_threeGOptIn label:after,
#div_id_fourGOptIn label:after {
    color: #212529;
    display: inline-block;
    padding: .25em .4em;
    font-size: 75%;
    font-weight: 700;
    line-height: 1;
    text-align: center;
    white-space: nowrap;
    vertical-align: baseline;
    border-radius: .25rem;
    width: auto;
    height: auto;
    position: inherit;
    background-image: none;
    transition: color .15s ease-in-out,background-color .15s ease-in-out,border-color .15s ease-in-out,box-shadow .15s ease-in-out;
}
#div_id_twoGOptIn label:after {
    background-color: #28a745;
    content: "Most stable";
}

#div_id_threeGOptIn label:after {
    background-color: #ffc107;
    content: "Testing";
}
#div_id_fourGOptIn label:after {
    background-color: #dc3545;
    content: "Highly experimental";
}
</style>

{% endblock %}

guru/core/templates/extension/user_list.html
{% extends "master.html" %}
{% load legacy_url %}

{% block content %}
{% if list_user %}
    <h1>Extension overview for {{ list_user.username }}</h1>
{% else %}
    <h1>Extension overview</h1>
{% endif %}
{% if currentEvent %}
<ul class="nav justify-content-end mb-2">
    <li class="nav-item">
        <a class="nav-link" href="{% legacy_url "extension.new" %}"><span class="oi oi-plus"></span> Add Extension for {{ currentEvent.name }}</a>
    </li>
    <li class="nav-item">
        <a class="nav-link" href="{% legacy_url "user.invoice" %}"><span class="oi oi-data-transfer-download"></span> Download invoice for {{ currentEvent.name }}</a>
    </li>
</ul>
{% endif %}

{% regroup object_list by event as event_list %}
{% for event, extension_list in event_list %}
<h3>{{event.name}}</h3>
<table class="table table-striped">
    <thead><tr>
        <th>Extension</th>
        <th>Name</th>
        <th>Type</th>
        <th>Actions</th>
    </tr></thead>
    <tbody>
        {% for ext in extension_list %}
        {% if request.user.is_staff or event == curentEvent or ext.inPhonebook or request.user == ext.owner %}
        <tr>
            <td>
            {% if ext.inPhonebook %}
                <span class="oi oi-eye" title="Listed in Phonebook" aria-hidden="true"></span>
            {% else %}
                <span class="oi oi-shield" title="Not in Phonebook" aria-hidden="true"></span>
            {% endif %}
            <a href="tel:{{ext.extension}}">{{ext.extension}}</a>
            </td>
            <td>{{ext.name}}</td>
            <td>
                {% if request.user.is_staff and ext.type == "GROUP" %}
                <a href="{% url "callgroup.admins" pk=ext.pk %}"><span class="oi oi-people" title="Call group admins" aria-hidden="true"></span></a>
                <a href="{% url "callgroup.members" pk=ext.pk %}"><span class="oi oi-list" title="Member extensions list" aria-hidden="true"></span></a>
                {% endif %}
                {{ext.get_type_display}}
            </td>
            <td>
                {% if request.user == ext.owner or request.user.is_staff or userIsCurrentEventAdmin and event == currentEvent %}
                <a href="{% legacy_url "extension.edit" pk=ext.pk next_url=signedCurrentURL %}"><span class="oi oi-pencil" title="Edit" aria-hidden="true"></span></a>
                <a href="{% url "extension.delete" pk=ext.pk %}?next={{request.path|urlencode}}"><span class="oi oi-x" title="Delete" aria-hidden="true"></span></a>
                {% if not event.isPast %}
                    <span class="keyEntry">{% include "extension/keyentry.html" %}</span>
                {% endif %}
                {% endif %}
            </td>
        </tr>
        {% endif %}
        {% endfor %}
    </tbody>
</table>
{% endfor %}
<script>
$(function () {
  $('[data-toggle="popover"]').popover()
})
</script>
{% endblock %}